Subject: Re: bug#55066: guix pull: error: You found a bug: the program '/gnu/store/mpfp9nrzifhp3r5s3bv05b8xal5aa44f-compute-guix-derivation'

From: Christopher Baines <[email-masked]>
Date: Fri, 22 Apr 2022 18:34:36 +0100

calcium via Bug reports for GNU Guix <[email-masked]> writes:

> 14.2 MB will be downloaded:
>   /gnu/store/5h2w4qi9hk1qzzgi1w83220ydslinr4s-glibc-2.33
>   /gnu/store/4jdghmc65q7i7ib89zmvq66l0ghf7jc4-glibc-2.33-static
>   /gnu/store/jwwvdgb3bgvbvbrd7k7zx2ircxhhrvd8-git-minimal-2.35.1
> substituting /gnu/store/jwwvdgb3bgvbvbrd7k7zx2ircxhhrvd8-git-minimal-2.35.1...
> Backtrace:

...

> ice-9/boot-9.scm:1685:16: In procedure raise-exception:
> ERROR:
>   1. &http-get-error:
>       uri: #<<uri> scheme: https userinfo: #f host: "bordeaux.guix.gnu.org" port: #f path: "/nar/lzip/jwwvdgb3bgvbvbrd7k7zx2ircxhhrvd8-git-minimal-2.35.1" query: #f fragment: #f>
>       code: 404
>       reason: "Not Found"
>       headers: ((server . "nginx") (date . #<date nanosecond: 0 second: 7 minute: 55 hour: 15 day: 22 month: 4 year: 2022 zone-offset: 0>) (content-type text/html) (content-length . 146) (connection keep-alive))
>   2. &message: "https://bordeaux.guix.gnu.org/nar/lzip/jwwvdgb3bgvbvbrd7k7zx2ircxhhrvd8-git-minimal-2.35.1: HTTP download failed: 404 (\"Not Found\")"
> substitution of /gnu/store/jwwvdgb3bgvbvbrd7k7zx2ircxhhrvd8-git-minimal-2.35.1 failed
> guix build: error: corrupt input while restoring archive from #<closed: file 7f382aa89070>

I believe the short explanation for this is that I made a mistake when
changing the NGinx configuration for bordeaux.guix.gnu.org, which
prevented it from serving nar files for a few minutes earlier today.

The longer explanation is that this is the error I'd expect when guix
finds a narinfo for a store item it wants to substitute, but can't fetch
the nar. Maybe it's possible to handle that scenario more gracefully,
but generally it doesn't happen, it only happens when substitute servers
misbehave.